diff --git a/lib/hive/setup/diagnostics.rb b/lib/hive/setup/diagnostics.rb
new file mode 100644
index 00000000..db4b6b76
--- /dev/null
+++ b/lib/hive/setup/diagnostics.rb
@@ -0,0 +1,539 @@
+# frozen_string_literal: true
+
+require "json"
+require "rbconfig"
+
+require "hive"
+require "hive/agent_profiles"
+require "hive/bounded_subprocess"
+require "hive/claude_launcher"
+require "hive/paths"
+require "hive/web/app_bundle"
+
+module Hive
+  module Setup
+    # Bounded preflight for `hive setup`. Each dependency becomes a Result
+    # with status, detail, an exact fix command (when applicable), and a
+    # `bootstrappable` flag. Only Hive-owned assets (qmd, the Rails web
+    # bundle) may be bootstrapped; external CLIs (gh/claude/codex) are never
+    # installed or authenticated by setup.
+    class Diagnostics
+      PROBE_TIMEOUT_SEC = 5
+      MIN_RUBY = "3.4.0"
+      MIN_TMUX = Hive::ClaudeLauncher::MIN_TMUX_VERSION
+      QMD_PACKAGE = "@tobilu/qmd"
+
+      STATUSES = %w[
+        ok
+        missing
+        outdated
+        unauthenticated
+        bootstrappable
+        error
+        unsupported
+      ].freeze
+
+      Result = Struct.new(
+        :name, :status, :detail, :fix, :bootstrappable, :path, :version,
+        keyword_init: true
+      ) do
+        def initialize(**kwargs)
+          super
+          self.status = status.to_s
+          self.bootstrappable = !!bootstrappable
+          unless STATUSES.include?(status)
+            raise ArgumentError, "invalid diagnostic status #{status.inspect}"
+          end
+        end
+
+        def ok?
+          status == "ok"
+        end
+
+        def hard_failure?
+          # Bootstrappable rows are recoverable by later setup phases.
+          !ok? && !bootstrappable && status != "unsupported"
+        end
+
+        def to_h
+          {
+            "name" => name,
+            "status" => status,
+            "detail" => detail,
+            "fix" => fix,
+            "bootstrappable" => bootstrappable,
+            "path" => path,
+            "version" => version
+          }
+        end
+      end
+
+      Report = Struct.new(:results, :platform, :ok, keyword_init: true) do
+        def to_h
+          {
+            "schema" => "hive-setup-diagnostics",
+            "schema_version" => 1,
+            "ok" => ok,
+            "platform" => platform,
+            "results" => results.map(&:to_h)
+          }
+        end
+
+        def hard_failures
+          results.select(&:hard_failure?)
+        end
+
+        def bootstrappable
+          results.select(&:bootstrappable)
+        end
+      end
+
+      def initialize(
+        env: ENV,
+        host_os: RbConfig::CONFIG["host_os"],
+        home: nil,
+        which: nil,
+        runner: nil,
+        app_bundle: nil,
+        agent_auth: nil,
+        gh_auth: nil,
+        probe_timeout: PROBE_TIMEOUT_SEC
+      )
+        @env = env
+        @host_os = host_os
+        @home = File.expand_path(home || env["HOME"] || Dir.home)
+        @which = which || method(:default_which)
+        @runner = runner || method(:default_runner)
+        @app_bundle = app_bundle
+        @agent_auth = agent_auth || method(:default_agent_logged_in?)
+        @gh_auth = gh_auth || method(:default_gh_logged_in?)
+        @probe_timeout = probe_timeout
+      end
+
+      def call
+        results = [
+          check_ruby,
+          check_binary("git", fix_missing: install_hint("git")),
+          check_tmux,
+          check_gh,
+          check_agent("claude", fix_login: "claude setup-token"),
+          check_agent("codex", fix_login: "codex login"),
+          check_binary("node", fix_missing: install_hint("node")),
+          check_binary("npm", fix_missing: install_hint("npm")),
+          check_qmd,
+          check_web_bundle,
+          check_sqlite
+        ]
+        Report.new(
+          results: results,
+          platform: platform_name,
+          ok: results.none?(&:hard_failure?)
+        )
+      end
+
+      private
+
+      def check_ruby
+        path = RbConfig.ruby
+        version = RUBY_VERSION
+        if (version_tuple(version) <=> version_tuple(MIN_RUBY)).negative?
+          return result(
+            "ruby",
+            status: "outdated",
+            detail: "ruby #{version} is below minimum #{MIN_RUBY}",
+            fix: install_hint("ruby"),
+            path: path,
+            version: version
+          )
+        end
+
+        result("ruby", status: "ok", detail: "ruby #{version}", path: path, version: version)
+      end
+
+      def check_tmux
+        path = @which.call("tmux")
+        unless path
+          return result(
+            "tmux",
+            status: "missing",
+            detail: "tmux not found on PATH",
+            fix: install_hint("tmux")
+          )
+        end
+
+        version = probe_version(path, %w[--version], /tmux\s+(\d+\.\d+(?:\.\d+)?)/i)
+        if version.nil?
+          return result(
+            "tmux",
+            status: "error",
+            detail: "could not parse tmux --version",
+            fix: install_hint("tmux"),
+            path: path
+          )
+        end
+
+        if (version_tuple(version) <=> version_tuple(MIN_TMUX)).negative?
+          return result(
+            "tmux",
+            status: "outdated",
+            detail: "tmux #{version} is below minimum #{MIN_TMUX}",
+            fix: install_hint("tmux"),
+            path: path,
+            version: version
+          )
+        end
+
+        result("tmux", status: "ok", detail: "tmux #{version}", path: path, version: version)
+      end
+
+      def check_gh
+        path = @which.call("gh")
+        unless path
+          return result(
+            "gh",
+            status: "missing",
+            detail: "gh not found on PATH",
+            fix: install_hint("gh")
+          )
+        end
+
+        version = probe_version(path, %w[--version], /gh version (\d+\.\d+\.\d+)/i)
+        unless @gh_auth.call
+          return result(
+            "gh",
+            status: "unauthenticated",
+            detail: "gh is installed but not authenticated",
+            fix: "gh auth login",
+            path: path,
+            version: version
+          )
+        end
+
+        result(
+          "gh",
+          status: "ok",
+          detail: version ? "gh #{version} authenticated" : "gh authenticated",
+          path: path,
+          version: version
+        )
+      end
+
+      def check_agent(name, fix_login:)
+        path = @which.call(name)
+        unless path
+          return result(
+            name,
+            status: "missing",
+            detail: "#{name} not found on PATH",
+            fix: install_hint(name)
+          )
+        end
+
+        version = probe_version(path, %w[--version], /(\d+\.\d+\.\d+)/)
+        unless @agent_auth.call(name)
+          return result(
+            name,
+            status: "unauthenticated",
+            detail: "#{name} is installed but not authenticated",
+            fix: fix_login,
+            path: path,
+            version: version
+          )
+        end
+
+        result(
+          name,
+          status: "ok",
+          detail: version ? "#{name} #{version} authenticated" : "#{name} authenticated",
+          path: path,
+          version: version
+        )
+      end
+
+      def check_binary(name, fix_missing:)
+        path = @which.call(name)
+        unless path
+          return result(name, status: "missing", detail: "#{name} not found on PATH", fix: fix_missing)
+        end
+
+        version = probe_version(path, %w[--version], /(\d+\.\d+(?:\.\d+)?)/)
+        result(
+          name,
+          status: "ok",
+          detail: version ? "#{name} #{version}" : "#{name} found",
+          path: path,
+          version: version
+        )
+      end
+
+      def check_qmd
+        path = find_qmd
+        if path
+          version = probe_version(path, %w[--version], /(\d+\.\d+\.\d+)/)
+          return result(
+            "qmd",
+            status: "ok",
+            detail: version ? "qmd #{version}" : "qmd found",
+            path: path,
+            version: version
+          )
+        end
+
+        unless @which.call("npm")
+          return result(
+            "qmd",
+            status: "missing",
+            detail: "qmd not found and npm is unavailable to bootstrap it",
+            fix: "#{install_hint('npm')}; then #{qmd_install_command}"
+          )
+        end
+
+        result(
+          "qmd",
+          status: "bootstrappable",
+          detail: "qmd not found; hive can install it under the managed prefix",
+          fix: qmd_install_command,
+          bootstrappable: true
+        )
+      end
+
+      def check_web_bundle
+        bundle = app_bundle
+        begin
+          path = bundle.resolve!(install: false)
+          detail =
+            if bundle.current_managed_bundle?
+              "managed web bundle #{Hive::VERSION}"
+            elsif @env[Hive::Web::AppBundle::ENV_APP_DIR].to_s == path ||
+                  File.expand_path(@env[Hive::Web::AppBundle::ENV_APP_DIR].to_s) == path
+              "Rails app via #{Hive::Web::AppBundle::ENV_APP_DIR}"
+            else
+              "Rails app available"
+            end
+          return result(
+            "web_bundle",
+            status: "ok",
+            detail: detail,
+            path: path,
+            version: bundle.current_managed_bundle? ? Hive::VERSION : bundle.installed_version
+          )
+        rescue Hive::Web::AppBundle::Error
+          # fall through to bootstrappable
+        end
+
+        if bundle.rails_app?(bundle.managed_app_dir)
+          installed = bundle.installed_version
+          return result(
+            "web_bundle",
+            status: "bootstrappable",
+            detail: "managed web bundle is stale (#{installed.inspect}); needs #{Hive::VERSION}",
+            fix: "hive setup  # refreshes web bundle to #{Hive::VERSION}",
+            path: bundle.managed_app_dir,
+            version: installed,
+            bootstrappable: true
+          )
+        end
+
+        result(
+          "web_bundle",
+          status: "bootstrappable",
+          detail: "Rails web bundle not installed for hive #{Hive::VERSION}",
+          fix: "hive setup  # downloads #{bundle.archive_basename}",
+          bootstrappable: true
+        )
+      end
+
+      def check_sqlite
+        # Prefer the sqlite3 gem (already a hive runtime dep) over a CLI.
+        begin
+          require "sqlite3"
+          version = defined?(SQLite3::SQLITE_VERSION) ? SQLite3::SQLITE_VERSION : SQLite3::VERSION
+          return result(
+            "sqlite",
+            status: "ok",
+            detail: "sqlite3 gem #{version}",
+            version: version.to_s
+          )
+        rescue LoadError
+          # fall through to CLI probe
+        end
+
+        path = @which.call("sqlite3")
+        unless path
+          return result(
+            "sqlite",
+            status: "missing",
+            detail: "sqlite3 gem and sqlite3 CLI are unavailable",
+            fix: install_hint("sqlite3")
+          )
+        end
+
+        version = probe_version(path, %w[--version], /(\d+\.\d+\.\d+)/)
+        result(
+          "sqlite",
+          status: "ok",
+          detail: version ? "sqlite3 #{version}" : "sqlite3 CLI found",
+          path: path,
+          version: version
+        )
+      end
+
+      def result(name, status:, detail:, fix: nil, bootstrappable: false, path: nil, version: nil)
+        Result.new(
+          name: name,
+          status: status,
+          detail: detail,
+          fix: fix,
+          bootstrappable: bootstrappable,
+          path: path,
+          version: version
+        )
+      end
+
+      def app_bundle
+        @app_bundle ||= Hive::Web::AppBundle.new(
+          env: @env,
+          data_home: Hive::Paths.data_home,
+          # Production diagnostics use the real source-checkout fallback.
+          # Tests inject an AppBundle with source_app_dir pointed at a
+          # non-existent path so the suite stays hermetic.
+          downloader: ->(*) { raise "diagnostics must not download" },
+          bundler: ->(*) { raise "diagnostics must not bundle install" }
+        )
+      end
+
+      def find_qmd
+        env_qmd = @env["HIVE_QMD_BIN"].to_s
+        return env_qmd if !env_qmd.empty? && File.executable?(env_qmd)
+
+        path_qmd = @which.call("qmd")
+        return path_qmd if path_qmd
+
+        data_home = Hive::Paths.data_home
+        candidates = [
+          File.join(data_home, "qmd", "bin", "qmd"),
+          File.expand_path("~/.local/share/hive/qmd/bin/qmd", @home)
+        ]
+        # Paths.expand with ~ uses HOME; keep explicit home-relative too.
+        candidates << File.join(@home, ".local/share/hive/qmd/bin/qmd")
+
+        prefix_file = File.join(data_home, "install-prefix")
+        if File.readable?(prefix_file)
+          prefix = File.read(prefix_file).lines.first.to_s.strip
+          candidates << File.join(prefix, "hive", "qmd", "bin", "qmd") unless prefix.empty?
+        end
+
+        candidates.find { |candidate| File.file?(candidate) && File.executable?(candidate) }
+      end
+
+      def qmd_install_command
+        prefix = File.join(Hive::Paths.data_home, "qmd")
+        "npm install --global --prefix \"#{prefix}\" #{QMD_PACKAGE}"
+      end
+
+      def install_hint(name)
+        case platform_name
+        when "macos"
+          case name
+          when "ruby" then "brew install ruby@3.4  # or install Ruby 3.4+ via mise/rbenv/asdf"
+          when "git" then "brew install git"
+          when "tmux" then "brew install tmux"
+          when "gh" then "brew install gh"
+          when "node", "npm" then "brew install node"
+          when "sqlite3" then "brew install sqlite"
+          when "claude" then "Install Claude Code: https://docs.anthropic.com/en/docs/claude-code"
+          when "codex" then "Install Codex CLI: https://github.com/openai/codex"
+          else "brew install #{name}"
+          end
+        when "linux"
+          case name
+          when "ruby" then "Install Ruby >= #{MIN_RUBY} via your package manager or mise/rbenv/asdf"
+          when "git" then "sudo apt-get install -y git  # or equivalent for your distro"
+          when "tmux" then "sudo apt-get install -y tmux  # or equivalent for your distro"
+          when "gh" then "See https://github.com/cli/cli#installation"
+          when "node", "npm" then "sudo apt-get install -y nodejs npm  # or equivalent for your distro"
+          when "sqlite3" then "sudo apt-get install -y sqlite3 libsqlite3-dev  # or equivalent"
+          when "claude" then "Install Claude Code: https://docs.anthropic.com/en/docs/claude-code"
+          when "codex" then "Install Codex CLI: https://github.com/openai/codex"
+          else "Install #{name} via your package manager"
+          end
+        else
+          "Install #{name} for your platform (Linux/macOS supported for local setup)"
+        end
+      end
+
+      def platform_name
+        case @host_os
+        when /darwin/i then "macos"
+        when /linux/i then "linux"
+        else "unsupported"
+        end
+      end
+
+      def probe_version(path, argv, pattern)
+        out, err, status = @runner.call([ path, *argv ])
+        return nil unless status
+
+        text = "#{out}\n#{err}"
+        match = text.match(pattern)
+        match && match[1]
+      rescue StandardError
+        nil
+      end
+
+      def default_which(name)
+        @env["PATH"].to_s.split(File::PATH_SEPARATOR).each do |dir|
+          path = File.join(dir, name)
+          return path if File.file?(path) && File.executable?(path)
+        end
+        nil
+      end
+
+      def default_runner(argv)
+        out, err, status = Hive::BoundedSubprocess.capture3(*argv, timeout: @probe_timeout)
+        [ out, err, status.success? ]
+      rescue Hive::BoundedSubprocess::TimeoutError, Errno::ENOENT, Errno::EACCES, SystemCallError
+        [ "", "", false ]
+      end
+
+      def default_agent_logged_in?(name)
+        return true if api_key_present?(name)
+
+        Hive::AgentProfiles.logged_in?(name, home: @home)
+      end
+
+      def api_key_present?(name)
+        case name.to_s
+        when "claude"
+          key_set?("ANTHROPIC_API_KEY") || key_set?("CLAUDE_API_KEY")
+        when "codex"
+          key_set?("OPENAI_API_KEY")
+        else
+          false
+        end
+      end
+
+      def key_set?(name)
+        value = @env[name].to_s.strip
+        !value.empty?
+      end
+
+      def default_gh_logged_in?
+        out, err, ok = default_runner(%w[gh auth status])
+        return true if ok
+
+        # Some gh versions write status details to stderr even on success.
+        text = "#{out}\n#{err}"
+        return true if text.match?(/Logged in to/i)
+
+        false
+      rescue StandardError
+        false
+      end
+
+      def version_tuple(version)
+        version.to_s.split(".").map(&:to_i)
+      end
+    end
+  end
+end
